<?php

declare(strict_types=1);

namespace hood\vk\api\methods;

<<<<<<< HEAD
use hood\vk\robots\robot,
    hood\vk\robots\group,
    hood\vk\robots\user;
=======
use Exception;

use hood\accounts\vk;
use hood\vk\robots\robot;
use hood\vk\api\attachments;
>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4

/**
 * Сообщение
 *
<<<<<<< HEAD
 * public static function put(RobotAbstract $from, int $to, string $message, int $mode = 2) Отправить сообщение
=======
 * @method public static function put(RobotAbstract $from, int $to, string $message, int $mode = 2) Отправить сообщение
>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4
 *
 * @see https://vk.com/dev/messages.send
 * @see https://vk.com/dev/messages.getById
 *
 * @package hood\vk\api
 * @author Arsen Mirzaev Tatyano-Muradovich <red@hood.su>
 *
 * @todo Доработать строгий режим отправки: проверку сообщения в беседе (не имеет ID сообщений)
 */
final class messages extends method
{
    /**
<<<<<<< HEAD
     * $mode Режим отправки
=======
     * @param int $mode Режим отправки
>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4
     */
    protected int $mode = 1;

    /**
<<<<<<< HEAD
     * Создать сообщение
     *
     * Если переданы все параметры, то сразу отправляет
     *
     * $robot Робот
     * $message Текст
     * $destination Получатель
     * $attachments Вложения
     *
     * @return self
     */
    public function __construct(
        protected robot $robot,
        protected string $message,
        protected int|string|array|null $destination = null,
        protected array $attachments = []
    ) {
        // Отправка, если все параметры инициализированы
        return $this->send($destination);
=======
     * @param string|null $text Текст
     */
    protected string|null $text = null;

    /**
     *  @var array Массив вложений
     */
    protected array $attachments;

    /**
     *  @var attachments Вложения
     */
    protected attachments $attachment;

    /**
     * Создать сообщение
     *
     * @param robot $robot Робот
     */
    public function __construct(
        protected robot $robot
    ) {
    }

    /**
     * Записать текст
     *
     * @param string $text Текст
     *
     * @return self
     */
    public function text(string $text): self
    {
        // Записать текст
        if (!isset($this->text)) {
            $this->text = $text;
        } else {
            $this->text .= $text;
        }

        return $this;
    }

    /**
     * Записать фото
     *
     * @param $img Фото
     *
     * @return self
     */
    public function image(...$imgs): self
    {
        // Перебор фото
        foreach ($imgs as $img) {

            // Загрузить фото
            $id = $this->robot->photo->getPhoto($img);

            // Записать к вложениям
            $this->attachment($id);
        }

        return $this;
    }

    /**
     * Записать вложение
     *
     * @param $attachments Вложения
     */
    public function attachment(string ...$attachments): self
    {
        if (isset($this->attachment)) {
            // Если вложения инициализированны

            // Записать вложение
            $this->attachment->attachment(...$attachments);
        } else {
            // Если вложения не инициализированны

            // Инициализация вложений
            $this->attachment = new attachments($this->robot);

            // Записать вложение
            $this->attachment->attachment(...$attachments);
        }

        return $this;
>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4
    }

    /**
     * Отправить сообщение
     *
<<<<<<< HEAD
     * $destination Получатель
     *
     * @see https://vk.com/dev/messages.send
     *
     * Ответ сервера
=======
     * @param int|string|array $destination Получатель
     *
     * @see https://vk.com/dev/messages.send
     *
     * @return array Ответ сервера
>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4
     */
    public function send(int|string|array $destination): array
    {
        // Идентификатор сообщения
        $random_id = time();

        if ($this->mode = 1) {
            // Перемножение (по умолчанию)
            $random_id *= rand();
        }

<<<<<<< HEAD
        # Ключ
        match (true) {
            // Робот-группа
            $this->robot instanceof group => $settings['access_token'] = $this->robot->key,
            // Робот-пользователь
            $this->robot instanceof User => $settings['access_token'] = $this->robot->key
        };

        // Версия API
        $settings['v'] = $this->robot->version;

        // Цель отправки
        match (true) {
            // Отправить по идентификатору
            is_int($destination) => $settings['peer_id'] = $destination,
            // Массовая отправка по идентификаторам
            is_array($destination) => $settings['user_ids'] = $destination,
                // Отправить по домену
            default => $settings['domain'] = $destination
        };

        // Сообщение
        $settings['message'] = $this->message;

        // Идентификатор сообщения
        $settings['random_id'] = $random_id;

        // Фильтрация вложений
        $forward_messages = [];
        foreach ($this->attachments as &$attachment) {
            //var_dump($attachment);
            if (iconv_substr($attachment, 0,  7, "UTF-8") === 'message') {
                // Если среди вложений найдено сообщение для пересылки
                $forward_messages[] = $attachment;
                unset($attachment);
            }
        }

        if (!empty($forward_messages)) {
            // Если есть пересылаемые сообщения
            $settings['forward_messages'] = implode(',', $forward_messages);
        }

        //var_dump($attachments);
        if (!empty($this->attachments)) {
            // Если есть вложения
            //echo 'lol';
            $settings['attachment'] = implode(',', $this->attachments);
            //var_dump($settings['attachment']);
        }

        // Запрос
        $request = $this->robot->browser->request(method: 'POST', uri: 'messages.send', options: ['form_params' => $settings]);

        // Очистка
        unset($settings);
=======
        // Реиницилазиция
        $this->robot->api->reinit();

        // Цель отправки
        $this->robot->api->chooseDestination($destination);

        // Текст сообщения
        $this->robot->api['message'] = $this->text;

        // Идентификатор сообщения
        $this->robot->api['random_id'] = $random_id;

        // Фильтрация вложений, если они инициализированны
        if (isset($this->attachments)) {
            $forward_messages = [];
            foreach ($this->attachments as &$attachment) {
                if (iconv_substr($attachment, 0,  7, "UTF-8") === 'message') {

                    // Если среди вложений найдено сообщение для пересылки
                    $forward_messages[] = $attachment;
                    unset($attachment);
                }
            }

            if (!empty($forward_messages)) {
                // Если есть пересылаемые сообщения
                $this->robot->api['forward_messages'] = implode(',', $forward_messages);
            }

            if (!empty($this->attachments)) {
                // Если есть вложения
                $this->robot->api['attachment'] = implode(',', $this->attachments);
            }
        }


        // Запрос
        $request = $this->robot->browser->request(method: 'POST', uri: 'messages.send', options: ['form_params' => $this->robot->api['settings']]);

        // Очистка
        //unset($settings);
>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4

        if ($this->mode >= 2) {
            // Если установлен режим 2 (усиленная проверка отправленного сообщения)

            if (!empty($request["response"])) {
                // Если пришел ID сообщения

<<<<<<< HEAD
                // Ключ
                match (true) {
                    // Робот-группа
                    $this->robot instanceof Group => $settings['access_token'] = $this->robot->key,
                    // Робот-пользователь
                    $this->robot instanceof User => $settings['access_token'] = $this->robot->key
                };

                // Версия API
                $settings['v'] = $this->robot->version;

                // Запрашиваемые сообщения
                $settings['message_ids'] = $request["response"];

                // Запрос
                if ($this->robot->browser->post(uri: 'https://api.vk.com/method/messages.getById', options: $settings)['response']['count'] === 0) {
=======
                // Реиницилазиция
                $this->robot->api->reinit();

                // Запрашиваемые сообщения
                $this->robot->api['message_ids'] = $request["response"];

                // Запрос
                if ($this->robot->browser->post(uri: 'https://api.vk.com/method/messages.getById', options: $this->robot->api['settings'])['response']['count'] === 0) {
>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4
                    // Если сообщения не существует, то повторить отправку
                    $this->send($destination);
                }
            } else {
                // Что-то придумать :)
            }
        }

        return (array) $request;
    }

    /**
<<<<<<< HEAD
     * Получить информацию о сообщении
     *
     * Информация о сообщении
     */
    public function info(): array
    {
        # Ключ
        match (true) {
            // Робот-группа
            $this->robot instanceof group => $settings['access_token'] = $this->robot->key,
            // Робот-пользователь
            $this->robot instanceof User => $settings['access_token'] = $this->robot->key,
        };

        // Цель отправки
        match (true) {
            // Отправить по идентификатору
            is_int($this->destination) => $settings['peer_id'] = $this->destination,
            // Массовая отправка по идентификаторам
            is_array($this->destination) => $settings['user_ids'] = $this->destination,
                // Отправить по домену
            default => $settings['domain'] = $this->destination
        };

        // Версия API
        $settings['v'] = $this->robot->version;

        // Сообщение
        $settings['message'] = $this->message;

        // Режим отправки
        $settings['mode'] = $this->mode;
=======
     * Записать свойство
     *
     * @param string $name Название
     * @param mixed $value Значение
     *
     * @return void
     */
    public function __set(string $name, mixed $value): void
    {
        match ($name) {
            'attachment' => !isset($this->attachments) ? $this->attachments = $value : throw new Exception('Запрещено перезаписывать вложения'),
            'attachments' => !isset($this->attachments) ? $this->attachments = $value : throw new Exception('Запрещено перезаписывать массив вложений'),
            default => throw new Exception('Свойство не найдено: ' . $name)
        };
    }

    /**
     * Прочитать свойство
     *
     * @param string $name Название
     *
     * @return mixed
     */
    public function __get(string $name): mixed
    {
        return match ($name) {
            'text' => $this->text ?? throw new Exception('Текст не задан'),
            'attachment' => $this->attachment->attachments ??  $this->attachment = new attachments($this->robot),
            'attachments' => isset($this->attachment) ? $this->attachment->attachments : throw new Exception('Вложения не инициализированны'),
            default => throw new Exception('Свойство не найдено: ' . $name)
        };
    }

    /**
     * Получить информацию о сообщении
     *
     * @return array Информация о сообщении
     */
    public function info(): array
    {
        //Инициализация
        //$settings = $this->init();
        $this->robot->api->init();

        // Цель отправки
        $this->robot->api->chooseDestination($this->destination);

        // Сообщение
        $this->robot->api['message'] = $this->message;

        // Режим отправки
        $this->robot->api['mode'] = $this->mode;
>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4

        // Фильтрация вложений
        $forward_messages = [];
        foreach ($this->attachments as &$attachment) {
            if (iconv_substr(str: $attachment, offset: 0, length: 7, charset: "UTF-8") === 'message') {
                // Если среди вложений найдено сообщение для пересылки
<<<<<<< HEAD
=======

>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4
                $forward_messages[] = $attachment;
                unset($attachment);
            }
        }

        if (!empty($forward_messages)) {
            // Если есть пересылаемые сообщения
<<<<<<< HEAD
            $settings['forward_messages'] = implode(',', $forward_messages);
=======

            $this->robot->api['forward_messages'] = implode(',', $forward_messages);
>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4
        }

        if (!empty($attachments)) {
            // Если есть вложения
<<<<<<< HEAD
            $settings['attachment'] = implode(',', $attachments);
        }

        return $settings;
=======

            $this->robot->api['attachment'] = implode(',', $this->attachments);
        }

        /////////////////////////////////////////////////............................ Что это?
        return $settings ?? [];
>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4
    }
}
