<?php

declare(strict_types=1);

namespace hood\vk\loggers;

/**
 * Абстрактный класс журналиста
 * 
 * @package hood\vk\loggers
 * @author Arsen Mirzaev Tatyano-Muradovich <red@hood.su>
 */
abstract class logger
{
    /**
     * Экземпляр класса журналиста
     *
     * @var logger
     */
    public static $logger;

    abstract static public function post($file = null): ?logger;
    abstract static public function get(): ?logger;
    abstract static public function delete(): ?logger;
}