<?php

declare(strict_types=1);

use PHPUnit\Framework\TestCase;

<<<<<<< HEAD
use hood\vk\core,
    hood\vk\robots\robot,
    hood\vk\tests\settings;
=======
use hood\vk\core;
use hood\vk\robots\robot;
use hood\vk\tests\settings;
>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4

use hood\accounts\vk as account;

/**
<<<<<<< HEAD
 * @testdox Робот-группа
=======
 * @testdox Сообщения
>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4
 */
final class messagesTest extends TestCase
{
    use settings;

    /**
     * @var core $core Ядро фреймворка
     */
    private static core $core;

    /**
     * @var account $account Аккаунт
     */
    protected static account $account;

    /**
     * @var robot $robot Робот
     */
    private static robot $robot;

<<<<<<< HEAD

    /**
     * @testdox Деинициализация аккаунта
     * @afterClass
     */
    public static function testAccountDeinit(): void
    {
        // Инициализация аккаунта
        self::$account = new account(empty(self::$id) ? rand(0, 10) : self::$id, __DIR__ . '../../accounts');

        // Деаутентификация
        self::$account->deauth();
    }

=======
>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4
    /**
     * @testdox Инициализация аккаунта
     * @beforeClass
     */
    public function testAccountInit(): void
    {
        // Проверка входных данных
        if (empty(self::$project_id)) {
            self::$markTestSkipped('Не найден идентификатор проекта');
        }

        // Инициализация аккаунта
<<<<<<< HEAD
        self::$account = new account(empty(self::$id) ? rand(0, 10) : self::$id, __DIR__ . '../../accounts');
=======
        self::$account = new account(empty(self::$id) ? rand(0, 10) : self::$id, __DIR__ . '../../../accounts');
>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4

        // Запись режима SSL-протокола
        self::$account->ssl = self::$ssl ?? true;

        if (empty(self::$key)) {
            // Если не указан ключ

            // Проверка входных данных
            if (empty(self::$login)) {
                self::$markTestSkipped('Не найден входной аккаунта');
            } else if (empty(self::$password)) {
                self::$markTestSkipped('Не найден пароль аккаунта');
            }

            // Деаутентификация (на всякий случай)
            self::$account->deauth();

            // Аутентификация и генерация ключа
            self::$key = self::$account->auth(self::$login, self::$password)->key(self::$project_id);
        }

        $this->assertNotNull(self::$key, 'Ошибка при инициализации ключа аккаунта');
    }

    /**
<<<<<<< HEAD
     * @testdox Деинициализация робота
     * @after
     */
    public function testRobotGroupDeinit(): void
    {
        // Очистка реестра
        self::$core->delete();

        // Проверка
        $this->assertEmpty(self::$core->get(self::$robot->id), 'Ошибка при деинициализации робота');
=======
     * @testdox Деинициализация аккаунта
     * @afterClass
     */
    public static function testAccountDeinit(): void
    {
        // Инициализация аккаунта
        self::$account = new account(empty(self::$id) ? rand(0, 10) : self::$id, __DIR__ . '../../../accounts');

        // Деаутентификация
        self::$account->deauth();
>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4
    }

    /**
     * @testdox Инициализация робота
     * @before
     */
    public function testRobotGroupInit(): void
    {
        // Инициализация ядра
        self::$core = core::init();

        // Сохранение количества роботов
        $count = self::$core->robots;

        // Инициализация робота
        self::$robot = self::$core->group(empty(self::$group_id) ? rand(0, 10) : self::$group_id);

        // Проверка
        $this->assertEquals(self::$core->robots, $count + 1, 'Ошибка при инициализации робота');
    }

<<<<<<< HEAD

    /**
     * @testdox Инициализация робота
     */
    public function testApiMethodMessagesNew(): void
    {
        var_dump(self::$robot->message('Тестирование отправки сообщения', self::$target_id ?? 'pizba228'));
    }
=======
    /**
     * @testdox Деинициализация робота
     * @after
     */
    public function testRobotGroupDeinit(): void
    {
        // Очистка реестра
        self::$core->delete();

        // Проверка
        $this->assertEmpty(self::$core->get(self::$robot->id), 'Ошибка при деинициализации робота');
    }

    /**
     * @testdox Чтение текста
     */
    public function testReadText(): void
    {
        // Проверка выброса исключения
        $this->expectExceptionMessage('Текст не задан');

        // Чтение текста
        self::$robot->message()->text;
    }

    /**
     * @testdox Запись текста
     */
    public function testWriteText(): void
    {
        // Запись текста
        self::$robot->message()->text('text');
    }

    /**
     * @testdox Запись текста (повторная)
     */
    public function testWriteTextWhenHeIsAlreadyWrited(): void
    {
        // Запись текста
        $message = self::$robot->message()->text('text');

        // Повторная запись текста
        $message->text('text');

        // Проверка
        $this->assertSame('texttext', $message->text);
    }

    /**
     * @testdox Запись фото
     */
    public function testWriteImage(): void
    {
        // Запись фото
        self::$robot->message()->text('img');
    }

    /**
     * @testdox Чтение Вложений
     */
    public function testReadAttachments(): void
    {
        // Проверка выброса исключеия
        $this->expectExceptionMessage('Вложения не инициализированны');

        // Проверка
        self::$robot->message()->attachments;
    }

    /**
     * @testdox Запись вложений
     */
    public function testWriteAttachments(): void
    {
        // Запись вложений
        self::$robot->message()->attachment('text');
    }

    /**
     * @testdox Отправка сообщения
     */
    public function testSend(): void
    {
        // Отправка сообщения
        self::$robot->key(self::$group_key)->message()->send('123');
    }

    /**
     * @testdox Отправка сообщеий (с вложениями)
     */
    public function testSendWithAttachments(): void
    {
        // Запись вложений
        $message = self::$robot->key(self::$group_key)->message()->attachment('text');

        // Отправка сообщения
        $message->send('123');
    }

    /**
     * @t estdox Отправка сообщеий (с пересылаемым сообщением)
     */
>>>>>>> a45b5c327511a74d1fae5ab0e3a1dcc68e7dc3b4
}
